	TITLE Euro Millionaire
*******************************************************
* Game where you have to become an  millionaire	*
* by answering 15 questions correctly. 			*
* original game: Kenzo Tomita and Ewoud Huysmans	*
* Translation by Michal De Coninck				*
* If you want to compile it do the following things:	*
* >rplcomp Aplet.s Aplet.c					*
* >sasm -B -W -a Aplet.l -o Aplet.o Aplet.c		*
* >sload -H Aplet.m						*
*******************************************************

INCLUDE =Entry39.h
INCLUDE =Common.h
INCLUDE =Command.h
ASSEMBLE

*************************************************
*		     Name of the Aplet			*
*************************************************

	Dir_Head 16,Euro Millionaire,601
*              ^1    ^2       ^3
* ^1=Lenght of the name of the aplet.
* ^2=Name of the aplet.
* ^3=Number of the library. This is necessary even if the library is empty. 

RPL
     StndtType			( This aplet skeleton will only provide access to the "C" type of aplet )
INCLUDE =Sharedvar.h
ASSEMBLE 
	Vfield  L34,IntTable
	CON(5)	=DOHSTR
	REL(5)  endLink
	Link	_Main	
	Link	_Entry
	Link	_Exit
	Link	_Action		( Include all the variables needed by the aplet structure )
	Link	_Lbl0
	Link	_Zmulti
	Link	_Zmultich
	Link	_ToonTekst
	Link	_GoedAntwoord?
	Link	_GoedAntwoord!
	Link	_Frame4Or2
	Link	_HulpLijn
	Link	_Gewonnen

endLink

RPL
DEFINE Main		INT_00
DEFINE Entry	INT_01
DEFINE Exit		INT_02
DEFINE Action	INT_03
DEFINE Lbl0		INT_04
DEFINE Zmulti	INT_05
DEFINE Zmultich	INT_06
DEFINE ToonTekst	INT_07
DEFINE GoedAntwoord?	INT_08
DEFINE GoedAntwoord!	INT_09
DEFINE Frame4Or2	INT_0A
DEFINE HulpLijn	INT_0B
DEFINE Gewonnen	INT_0C

ASSEMBLE
	Vfield  IntTable,DirVar
RPL
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)  endCode
RPL

* The HP39/40G provides a list of 91 TopicVariables that can contain any kind of object
* Instead of using local variables as on the HP48/49, it's a good idea to use these
* variables instead. The access is really fast and easy. The contain of these variables
* will be preserved while the aplet is running. If you're exiting the view or
* switch to another aplet, the content will be deleted.
* To ease the access to your variables, use alias like:

DEFINE  VarQuit! TopicVar31!
DEFINE  VarQuit@ TopicVar31@
DEFINE  HelpUsed! TopicVar31!
DEFINE  HelpUsed@ TopicVar31@
DEFINE  LijstPE! TopicVar31!
DEFINE  LijstPE@ TopicVar31@
DEFINE  K! TopicVar30!
DEFINE  K@ TopicVar30@
DEFINE  J! TopicVar29!
DEFINE  J@ TopicVar29@
DEFINE  Menu! TopicVar28!
DEFINE  Menu@ TopicVar28@
DEFINE  M! TopicVar27!
DEFINE  M@ TopicVar27@
DEFINE  I! TopicVar26!
DEFINE  I@ TopicVar26@
DEFINE  Y! TopicVar25!
DEFINE  Y@ TopicVar25@
DEFINE  X! TopicVar24!
DEFINE  X@ TopicVar24@
DEFINE  P! TopicVar23!
DEFINE  P@ TopicVar23@
DEFINE  String6! TopicVar22!
DEFINE  String6@ TopicVar22@
DEFINE  B! TopicVar21!
DEFINE  B@ TopicVar21@
DEFINE  String5! TopicVar20!
DEFINE  String5@ TopicVar20@
DEFINE  String3! TopicVar19!
DEFINE  String3@ TopicVar19@
DEFINE  String4! TopicVar18!
DEFINE  String4@ TopicVar18@
DEFINE  String7! TopicVar17!
DEFINE  String7@ TopicVar17@
DEFINE  String2! TopicVar16!
DEFINE  String2@ TopicVar16@
DEFINE  String1! TopicVar15!
DEFINE  String1@ TopicVar15@
DEFINE  String0! TopicVar14!
DEFINE  String0@ TopicVar14@
DEFINE  A! TopicVar13!
DEFINE  A@ TopicVar13@
DEFINE  Omega! TopicVar12!
DEFINE  Omega@ TopicVar12@
DEFINE  Z! TopicVar11!
DEFINE  Z@ TopicVar11@
DEFINE  Lijst1! TopicVar10!
DEFINE  Lijst1@ TopicVar10@
DEFINE  Lijst6! TopicVar9!
DEFINE  Lijst6@ TopicVar9@
DEFINE  String9! TopicVar8!
DEFINE  String9@ TopicVar8@
DEFINE  String8! TopicVar7!
DEFINE  String8@ TopicVar7@
DEFINE  V! TopicVar6!
DEFINE  V@ TopicVar6@
DEFINE  G! TopicVar5!
DEFINE  G@ TopicVar5@
DEFINE  H! TopicVar4!
DEFINE  H@ TopicVar4@
DEFINE  Lijst5! TopicVar3!
DEFINE  Lijst5@ TopicVar3@
DEFINE  LijstHU! TopicVar2!
DEFINE  LijstHU@ TopicVar2@
DEFINE  LijstJK! TopicVar1!
DEFINE  LijstJK@ TopicVar1@


DEFINE	Save@	LastBut3
DEFINE	Save!	LastBut3 REPLACE DROP

ASSEMBLE
=DISPXYmini	EQU	#3F8A0					( unsupported entry for use of the minifont )
=TOD	EQU	#3F755						( unsupported entry for knowing the time on the calc )
RPL

*************************************************

*	         Self-made variables			*
*************************************************
* ici

NAMELESS _Main
  ::
     StndCheck
     ' Entry
     ' Exit
     '
	::
	EnsureMenuOff
	;
     '
	::
	  {
	   { kcSymbView :: TakeOver Action ;	( Enter or Symb to continue the program )
	     kcEnter :: TakeOver Action ;
	   }
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
          }
          ONE KeyFace
       ;
    TRUE
   {
   {
	::
	;
    }
    }
    ONE
    '
    ::	TURNMENUON RECLAIMDISP
	ERRJMP
    ;
  ;
NAMELESS _Entry
::
*************************************************
*		Begin of the presentation		*
*************************************************

GARBAGE								( defragmentation of the RAM )
TURNMENUOFF								( turn menu off )
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP	( clear screen )

%1 G!
%1 H!
ZERO DUPDUP V!								( current question )
HelpUsed! VarQuit!

{ ZERO ZERO } LijstJK!						( needed for 50/50 help line )
{ ZERO ZERO ZERO } LijstHU!					( help line list 1= used 0= not used )

BINT47 EIGHT 		 					( coordinates for text )
$ "Welcome to,"							( string to be displayed )
ToonTekst								( routine to display the text using the minifont, see below, )

TWENTYFOUR TWENTYONE
$ "Who wants to become an"
ToonTekst

BINT35 TWENTYSEVEN
$ "euro millionaire!"
ToonTekst

TWENTY BINT45
$ " to start press Enter..."
ToonTekst

{ % 25 % 50 % 100 % 200 % 500 % 1000 % 2000 % 5000 % 10000 % 20000 % 50000 % 100000 % 200000 % 500000 % 1000000 } Lijst5! 

TOD %RANDOMIZE							( use current time as seed for the random numbers )

**************************************************
*		  End of the presentation		 *
**************************************************
;

NAMELESS _Action
::
*************************************************
*		      Begin of the program		*
*************************************************
RDROP

V@ ZERO #<= EQUAL IT
IT
::
"^How many eyes has an tarantula?^How many different kings hasBelgium had since 1830?^Situate the investiure battlein time...^What means Eskimo?^What is the capital of Australia?^How many aliens movies could yousee in the cinema?^Where is Pearl Habour situated?^How long did Robinson Crusoestay on his island?^What was the name of thegroup from Bob Marly?^Which language do they speak inBrazil?^What did Prometheus stole?^What is the number of James Bond?^When did the battle ofWaterloo have place?^When was the bra discovered>^When celebrate they new year inChina?^How is the wife called fromPopeye?^How many lifes has a cataccording to the legend?^How many legs does a spiderhave?^Which country lays betweenRomania and Greece?^What is the capital of Croatia?^Which famous composer sufferedfrom deafness on his 26th?^Which drink was inventedin 1886?^Which was the nationality ofthe physicist 'Celcius'?^" String8!

"^2468^6789^1000102510501075^Fish eaterMeat eaterIce breederIce man^CanberraQuebecSydneyMelbourne^2345^HawaTahitiBora BoraMexico^12 year28 year37 year44 year^Bob MarlyJointloveThe WailersThe nodays^PortugeseSpanishBrazilianItalian^A fridgeWisdomRainFire^003005007008^1815182118251832^1889190919191935^DecemberJanuarFebruarMarch^PopySpruitjeLilyOliv^791113^46810^HungaryBulgaryMacedoniaAlbania^ZagrebLjubljanaBelgradoSarajevo^MozartBeethovenSchubertVivaldi^Kough syrupCoca-ColaCoffeeTonic^BelgianFrenchmanDanishSwedish^" String9!

{ FOUR ONE FOUR TWO ONE THREE ONE TWO THREE ONE FOUR THREE ONE ONE THREE FOUR TWO THREE TWO ONE TWO TWO FOUR } Lijst6!
;

V@ FIVE EQIT
:: 
 "^In which city did JohnFitzgerald Kennedy gotshot?^Where does somebodysuffer from when helooks squinting?^Triton is a satellite from whatplanet?^Where lays Papete?^How many works did Herculesaccomplish?^Titan is a moon from whichplanet?^Who did say: to be or not to be?^In what year did the Titanicsink?^How many Milky ways are known+/- in the universe?^Who did we call Duce?^How much does a diamondweight from 1 carat?^From which year does thedeclaration of human rightsexsist?^Who has had the mostexpensive funeral ever?^Which musicstyle started themovie 'saturdaynight' fever?^What is the kiwi?^In which country is burpingafter dinner a sign ofpoliteness?^Where lays Bali?^Which day do we call 'D-day'?^How many satellites doesSaturn have?^How many symphonies didBeethoven write?^What means 'Amen'?^Armstrong said: it's a smallstep for men, but one giantleap for...?^What is a lutra lutra?^" String8!

"^DallasNew YorkDenverChicago^MyopieAstimgieStrabismusStromonie^SaturnNeptuneMarsVenus^HaitiTahitiHawaiCuba^7101213^SaturnusNeptunusJupiterVenus^OthelloKing LearPolluxHamlet^1906191219271933^5 million50 million5 billion50 billion^CaesarMoussoliniNapoleonMaximianus^0.2 gram0.4 gram0.7 gram1.0 gram^1945194819551968^KennedyLeninHiro-HitoRamses II^DiscoJazzHip-HopCountry^VegetableFishTreeBird^IndiaChinaJapanTaiwan^IndonesiaPolynesiaCaraibenMalesia^2 June 19444 June 19446 June 19448 June 1944^091218^891012^Thank youSo be itForgive usHelp us^A dwarfThe spaceThe worldHumanity^WoodpeckerBatOtterDear^" String9!

{ ONE THREE TWO TWO THREE ONE FOUR TWO FOUR TWO ONE TWO THREE ONE FOUR TWO ONE THREE FOUR TWO TWO FOUR THREE } Lijst6!

;

V@ TEN EQIT 
::
"^Which pope did 'disappear'nine days in 1582?^Which city opened the firstaquarium in 1893?^Which of these does adactylographer study?^How is the three called onwhich the kiwi grows?^Which emperor did fall inlove with Cleopatra?^When is the paperclip patentedby John Vaaler?^What is a Phthirus Pubis?^What is a capreolus capreolus?^In which century didCopernicus live?^How many (known) planets arebigger than earth?^" String8!

"^GregoriusPaulusAntoniusBonifatius^ChicagoGentSeattleBarcelona^BonesInsectsFingerprintsReptiles^kiwitreeKiwishrubKiwidiaactinidia^CaesarMarcusOctavianusTraianus^Never185918991919^Indian rhinoApehedgehogPimple^WaterduckdearTunaOtter^14th-15th15th-16th16th-17th17th-18th^1234^" String9!

{ ONE ONE THREE FOUR ONE THREE ONE TWO TWO FOUR } Lijst6!					( the good answers )

;

NULL{} Lijst1!									( make an empty list and put it in List1 )

%0 Lijst6@ LENCOMP NDUPN DROP Lijst6@ LENCOMP {}N Lijst1! 		( puts as many elements List6 counts in list1 )
											
COLA Lbl0

**************************************************
*		       End of the program		*
**************************************************
;

NAMELESS _Lbl0
::
RDROP
%RAN Lijst6@ LENCOMP UNCOERCE %* %IP %1 %+ COERCE Omega!		( pick a rand n where we start searching for a question )
Lijst1@ LENCOMP UNCOERCE
Lijst1@ x\85LIST EQUAL IT :: COLA Entry ; 
Lijst1@ Omega@ NTHCOMPDROP %1 EQIT :: COLA Lbl0 ;

%1 Omega@ Lijst1@ PUTLIST Lijst1!
ZERO Z!

Omega@ #1+_ONE_DO (DO)							( begin for statement )
String8@
"^"
Z@ #1+ 
POS$
Z!
INDEX@
LOOP										( end of FOR statement )

String8@
"^"
Z@ #1+ 
POS$
A!

String8@
Z@ #1+ A@ #1-
SUB$
String0!

NULL$ DUPDUP String1! String2! String7!

String0@ 
""
ONE 
POS$
A!

A@ ZERO #<= ITE :: String0@ String1! ;
::
String0@
ONE A@ #1-
SUB$
String1!

String0@
""
A@ #1+
POS$
P!

P@ ZERO #<= ITE :: String0@ A@ #1+ String0@ LEN$ SUB$ String2! ;
::
String0@ A@ #1+ P@ #1- SUB$ String2!
String0@ P@ #1+ String0@ LEN$ P@ #+ SUB$ String7!
;									( end of IT )
;									( end of IT*2* )

ZERO Z!

Omega@ #1+_ONE_DO (DO)
String9@
"^"
Z@ #1+
POS$
Z!
INDEX@
LOOP

String9@
"^"
Z@ #1+ 
POS$
A!

String9@
Z@ #1+ A@ #1- 
SUB$
String0!								( the string with all the answers )

String0@ 
""
ONE 
POS$
A!

String0@
ONE A@ #1-
SUB$
String3!								( = answer 1 ) 

String0@
"" A@ #1+ 
POS$
P!

String0@
A@ #1+ P@ #1- 
SUB$
String4!								( = answer 4 )

String0@
""
P@ #1+
POS$
A!

String0@
P@ #1+ A@ #1-
SUB$
String5!								( = answer 3 )

String0@
A@ #1+
String0@ LEN$
SUB$
String6!								( = answer 2 )

V@ #1+ V!
Lijst5@ V@ NTHCOMPDROP B!
Zmulti
;									( end of Lbl0 )

NAMELESS _Zmulti
::
RDROP
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP	( clear screen )

ONE DUP								( coordinates for text )
$ "Question " V@ UNCOERCE DO>STR &$ " for " &$ Lijst5@ V@ NTHCOMPDROP DO>STR &$ " Euro" &$
ToonTekst

ZERO SEVEN BINT_131d SEVEN LINEON  				( draw some lines on the screen )
ZERO THIRTYSEVEN BINT_131d THIRTYSEVEN LINEON
ZERO BINT47 BINT_131d BINT47 LINEON
BINT61 BINT37 BINT71 BINT47 LINEON
BINT61 BINT47 BINT71 BINT37 LINEON
BINT62 BINT37 BINT70 BINT37 LINEOFF
BINT62 BINT47 BINT70 BINT47 LINEOFF

ZERO BINT50 BINT_131d BINT50 LINEON
ZERO BINT60 BINT_131d BINT60 LINEON
BINT61 BINT50 BINT71 BINT60 LINEON
BINT61 BINT60 BINT71 BINT50 LINEON 
BINT62 BINT50 BINT70 BINT50 LINEOFF
BINT62 BINT60 BINT70 BINT60 LINEOFF

ONE BINT40
String3@								( display anwser 1 on the screen )						
ToonTekst
ONE BINT53 
String5@								( display answer 3 on the screen )
ToonTekst
BINT73 BINT40
String4@								( display answer 2 on the screen )
ToonTekst
BINT73 BINT53
String6@								( display answer 4 on the screen )
ToonTekst

ONE TEN
String1@								( phrase 1 of the question on the screen )
ToonTekst
ONE SIXTEEN
String2@								( phrase 2 of the question on the screen )
ToonTekst
ONE TWENTYTWO
String7@								( phrase 3 of the question on the screen )
ToonTekst
COLA Zmultich
;									( end of Zmulti )

NAMELESS _Zmultich
::
ZERO X!
BEGIN
X@ ONE EQUALNOT X@ TWO EQUALNOT AND X@ THREE EQUALNOT AND X@ FOUR EQUALNOT AND X@ SIX EQUALNOT AND
WHILE
GETTOUCH ITE X! :: ZERO X! ;  
REPEAT

X@ I!

X@ LijstJK@ ONE NTHCOMPDROP EQ X@ LijstJK@ TWO NTHCOMPDROP EQ OR IT :: ZEROZERO X! I! COLA Zmultich ;

I@ BINT6 EQIT :: ZEROZERO I! X! COLA HulpLijn ;

HARDBUFF ZERO NINE BINT_131d BINT33 GROB!ZERODRP

"Is " 

I@ BINT1 EQIT :: String3@ &$ ;		( displays option 1 as good answer )
I@ BINT2 EQIT :: String4@ &$ ;		( displays option 2 as good answer )
I@ BINT3 EQIT :: String5@ &$ ;		( displays option 3 as good answer )
I@ BINT4 EQIT :: String6@ &$ ;		( displays option 4 as good answer )

ONE TEN
THREE ROLL
ToonTekst
ONE SEVENTEEN
$ "Your final answer?"
ToonTekst
ONE TWENTYFOUR
$ "(Yes/No)"
ToonTekst

ZERO X!
BEGIN
X@ BINT44 EQUALNOT X@ BINT31 EQUALNOT AND
WHILE
GETTOUCH ITE X! :: ZERO X! ;
REPEAT

X@ BINT31 EQIT Zmulti
{ ZERO ZERO } LijstJK!
HARDBUFF ZERO NINE BINT_131d BINT32 GROB!ZERODRP

ONE TEN
"Busy with checking..."
ToonTekst

I@ BINT2 EQ I@ BINT4 EQ OR IT Frame4Or2

BINT51 M!
I@ BINT1 EQIT :: BINT38 M! ;

BINT62 ZERO
DO
INDEX@ M@ INDEX@ M@ EIGHT #+ TOGLINE
LOOP

BINT62 M@ #1+ OVER M@ SEVEN #+ LINEON
BINT63 M@ #1+ OVER M@ SEVEN #+ LINEON 
BINT64 M@ TWO #+ OVER M@ SIX #+ LINEON
BINT65 M@ THREE #+ OVER M@ FIVE #+ LINEON 
BINT66 M@ FOUR #+ PIXON
	
GoedAntwoord?							( routine that checks if the answer is correct )	
;									( end of Zmultich )


NAMELESS _GoedAntwoord?
::
I@									( checks for a good answer )
Lijst6@ Omega@ NTHCOMPDROP EQIT GoedAntwoord!		( you have it right! )

ONE TEN								( else you have it wrong )
$ "That is the wrong answer!" 
ToonTekst
V@ #1+ V!
WaitForKey

HARDBUFF ZERO NINE BINT_131d BINT32 GROB!ZERODRP

ONE TEN
"The correct answer was: "
ToonTekst

Lijst6@ Omega@ NTHCOMPDROP ONE EQIT			( if the good answer was 1 )
::
ONE EIGHTEEN
String3@
ToonTekst
;

Lijst6@ Omega@ NTHCOMPDROP TWO EQIT			( if the good answer was 2 )
::
ONE EIGHTEEN
String4@
ToonTekst
;

Lijst6@ Omega@ NTHCOMPDROP THREE EQIT		( if the good answer was 3 )
::
ONE EIGHTEEN
String5@
ToonTekst
;

Lijst6@ Omega@ NTHCOMPDROP FOUR EQIT		( if the good answer was 4 )
::
ONE EIGHTEEN
String6@
ToonTekst
;

BINT25 BINT26 
"Thank you for entry!" 						( thanks for playing )
ToonTekst

WaitForKey								( display it till a key is pressed )
Entry
;									( end of GoedAntwoord? )

NAMELESS _GoedAntwoord!
::
RDROP
V@ FIFTEEN EQIT :: V@ #1+ V! COLA Gewonnen ;		( if 15 questions correctly answered goto win sequence )

ONE TEN
$ "The answer is correct!"
ToonTekst

"U have "

V@ FIVE EQIT :: ONE TWENTYONE THREE ROLL  "500 Euro" &$ ToonTekst ;

V@ TEN EQIT ::  ONE TWENTYONE THREE ROLL "20 000 Euro" &$ ToonTekst ; 

DROP
WaitForKey
V@ TEN EQ V@ FIVE EQ OR IT :: COLA Action ;
COLA Lbl0 
;									( end of GoedAntwoord! )

NAMELESS _Frame4Or2
::
RDROP
BINT51 M!
I@ BINT2 EQIT :: BINT38 M! ;				( if it's the second frame put another n in M )

BINT70 M@ #1+ OVER M@ SEVEN #+ LINEON 			( make the frame inverted )
BINT69 M@ TWO #+ OVER M@ SIX #+ LINEON
BINT68 M@ THREE #+ OVER M@ FIVE #+ LINEON 
BINT67 M@ FOUR #+ PIXON

BINT_131d BINT71							( make the frame inverted )
DO
INDEX@ M@ INDEX@ M@ EIGHT #+ TOGLINE
LOOP

GoedAntwoord?
;									( end of Lbl42 )

NAMELESS _HulpLijn						( helpline )
::
RDROP 

$ "Options"
{
{ "Money tree" FOUR }
{ "Quit" FIVE }
{ "Go back" SIX }
}

LijstHU@ THREE NTHCOMPDROP ZERO EQIT			( if other question isn't used yet )
::
{ { "Other question" THREE } }
SWAP &COMP
;

LijstHU@ TWO NTHCOMPDROP ZERO EQIT				( if other question isn't used yet )
::
{ { "Ask crowd" TWO } }
SWAP &COMP
;

LijstHU@ ONE NTHCOMPDROP ZERO EQIT				( if other question isn't used yet )
::
{ { "50/50" ONE } }
SWAP &COMP
;

ChooseSimple NOTcase :: TURNMENUOFF COLA Zmulti ;

Menu!

Menu@ ONE EQIT
::
TURNMENUOFF

ONE ONE LijstHU@ PUTLIST LijstHU!

BEGIN
%RAN %4 %* %IP %1 %+ COERCE J!
%RAN %4 %* %IP %1 %+ COERCE K!
K@ J@ EQUALNOT J@ Lijst6@ Omega@ NTHCOMPDROP EQUALNOT AND K@ Lijst6@ Omega@ NTHCOMPDROP EQUALNOT AND
UNTIL	

K@ ONE EQUAL J@ ONE EQUAL OR
IT :: NULL$ String3! ;

K@ TWO EQUAL J@ TWO EQUAL OR
IT :: NULL$ String4! ;

K@ THREE EQUAL J@ THREE EQUAL OR
IT :: NULL$ String5! ;

K@ FOUR EQUAL J@ FOUR EQUAL OR
IT :: NULL$ String6! ;
	
J@ ONE LijstJK@ PUTLIST LijstJK!
K@ TWO LijstJK@ PUTLIST LijstJK!
HelpUsed@ ZERO EQIT RDROP
COLA Zmulti
ONE HelpUsed!
;									( end of menu option 1 )

Menu@ TWO EQIT
::
ONE TWO LijstHU@ PUTLIST LijstHU!
TURNMENUOFF
HARDBUFF ZERO NINE BINT_131d BINT32 GROB!ZERODRP
ONE TEN
$ "Everybody may now vote..."
ToonTekst
%.5 DOWAIT
{ %0 %0 %0 %0 } LijstPE!
%RAN % 30 %* %IP %1 %+ COERCE Z!
Z@ V@ #< IT :: %RAN % 10 %* %IP %1 %+ ;
Z@ V@ #>= IT :: %RAN % 14 %* %IP % 10 %+ ;
%3 %* Lijst6@ Omega@ NTHCOMPDROP LijstPE@ PUTLIST LijstPE!
FIVE ONE_DO (DO)
INDEX@ Lijst6@ Omega@ NTHCOMPDROP EQUALNOT
IT
::
%RAN % 100 LijstPE@ x\85LIST %- %* %IP %1 %+
INDEX@ LijstPE@ PUTLIST LijstPE!
THIRTY LijstPE@ INDEX@ NTHCOMPDROP #<
IT
::
LijstPE@ INDEX@ NTHCOMPDROP %RAN % 11 %* %IP %1 %+ %- INDEX@ LijstPE@ PUTLIST LijstPE! 
;									( end of second IT ) 
;									( end of first IT )
LOOP 
HARDBUFF ZERO NINE BINT_131d BINT32 GROB!ZERODRP
%RAN %4 %* %IP %1 %+ COERCE DUP
LijstPE@ SWAP NTHCOMPDROP % 100 %+ LijstPE@ x\85LIST %- SWAP LijstPE@ PUTLIST LijstPE!
FIVE ONE_DO (DO)
TWO INDEX@ SIX #* FOUR #+
INDEX@ UNCOERCE DO>STR
ToonTekst 
LijstPE@ INDEX@ NTHCOMPDROP #1+_ONE_DO (DO)
INDEX@ FIVE #+ JINDEX@ SIX #* FOUR #+
FOUR LijstPE@ JINDEX@ NTHCOMPDROP COERCE
MAKEGROB
INVGROB
XYGROBDISP
LOOP 
LijstPE@ INDEX@ NTHCOMPDROP %7 %+ COERCE INDEX@ SIX #* FOUR #+
LijstPE@ INDEX@ NTHCOMPDROP DO>STR
ToonTekst
LOOP
WaitForKey
HelpUsed@ ZERO EQIT RDROP
COLA Zmulti
ONE HelpUsed!
;									( end of menu option 2 )

Menu@ THREE EQIT
::
TURNMENUOFF
ONE THREE LijstHU@ PUTLIST LijstHU!
V@ #1- V!
{ ZERO ZERO } LijstJK!
HelpUsed@ ZERO EQIT RDROP
COLA Lbl0
ONE HelpUsed!
;									( end of menu option 3 )

Menu@ FOUR EQIT
::
TURNMENUOFF
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP
FIVE #1+_ONE_DO (DO)
TEN INDEX@ SIX #* FIVE #-
Lijst5@ SIXTEEN INDEX@ #- NTHCOMPDROP DO>STR
ToonTekst 
V@ SIXTEEN INDEX@ #- EQIT
::
ONE INDEX@ SIX #* FIVE #-
CHR_->
CHR>$
ToonTekst
;									( end of IT )
LOOP

ELEVEN SIX DO
BINT45 INDEX@ SIX #* TWENTYTWO #-
Lijst5@ SIXTEEN INDEX@ #- NTHCOMPDROP DO>STR
ToonTekst 
V@ TEN #> EQIT
::
BINT38 BINT14 
$ "{ 20000 }"
ToonTekst
;									( end of IT )
V@ SIXTEEN INDEX@ #- EQIT
::
BINT39 INDEX@ SIX #* TWENTYTWO #-
CHR_->
CHR>$
ToonTekst
;									( end of IT )
LOOP

FIFTEEN #1+ ELEVEN DO
BINT75 INDEX@ SIX #* BINT35 #-
Lijst5@ SIXTEEN INDEX@ #- NTHCOMPDROP DO>STR
ToonTekst 
V@ FIVE #> V@ ELEVEN #< AND EQIT
::
BINT70 BINT31 
$ "{ 500 }"
ToonTekst
;									( end of IT )
V@ SIXTEEN INDEX@ #- EQIT
::
BINT66 INDEX@ SIX #* BINT35 #-
CHR_->
CHR>$
ToonTekst
;									( end of IT )
LOOP
WaitForKey
Zmulti
;									( end of menu option 4 )

Menu@ FIVE EQIT
::
TURNMENUOFF
HARDBUFF ZERO NINE BINT_131d BINT33 GROB!ZERODRP

ONE TEN
$ "Are you sure you want to quit?"
ToonTekst
ONE SEVENTEEN
$ "(Yes/No)"
ToonTekst

ZERO X!
BEGIN
X@ BINT44 EQUALNOT X@ BINT31 EQUALNOT AND
WHILE
GETTOUCH ITE X! :: ZERO X! ;
REPEAT

HARDBUFF ZERO NINE BINT_131d BINT33 GROB!ZERODRP
X@ BINT31 EQIT Zmulti
V@ ONE EQITE
::
ONE TEN
$ "Then I send you home"
ToonTekst
ONE SEVENTEEN
$ "With no money but with an"
ToonTekst
ONE TWENTYFOUR
$ "applause of our audience!"
;									( first ITE done )
::
ONE TEN
$ "Then I send you home with this"
ToonTekst
ONE SEVENTEEN
$ "cheque of " Lijst5@ V@ #1- NTHCOMPDROP DO>STR &$ " euro" &$
ToonTekst
ONE TWENTYFOUR
$ "Congratulations! (applause)"
;
ToonTekst
WaitForKey
Entry
;

Menu@ SIX EQIT
::
TURNMENUOFF								( turns menu back off ) 
COLA Zmulti								( go back to ZMulti )
;									( end of go back option )
;

NAMELESS _Gewonnen
::
RDROP
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP

BINT62 BINT25
$ "U"
ToonTekst
%1 DOWAIT

HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP

BINT56 BINT25
$ "have"
ToonTekst
%1 DOWAIT

HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP

BINT58 BINT25
$ "won"
ToonTekst
%1 DOWAIT

HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP

BINT40 BINT25 
$ "1 000 000 Euro"
ToonTekst

%1 DOWAIT

BINT30 ONE_DO (DO)
%RAN % 123 %* %IP COERCE 
%RAN % 56 %* %IP COERCE
GROB 1A 800008000087C0E3C0E3C0C087
XYGROBDISP
LOOP

FIVE #1+_ONE_DO (DO)
ZEROZERO
HARDBUFF 
ZEROZERO BINT_131d SIXTYFOUR 
SUBGROB
INVGROB
XYGROBDISP
%.5 DOWAIT
LOOP

HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP
ONE ONE 
$ "Thanks to..."
ToonTekst
ONE TEN
$ "Kenzo Tomita and Ewoud Huyswoud"
ToonTekst
ONE BINT16
$ "for the TI-83 version"
ToonTekst
ONE BINT22
"Endemol for making the tv series"
ToonTekst
ONE BINT28
$ "Daniel for beta-testing"
ToonTekst
ONE BINT34
$ "You for playing"
ToonTekst
ONE BINT40
$ "Colin for helping with the"
ToonTekst
ONE BINT46
$  "English translation"
ToonTekst
ONE BINT52
$ "Everybody else I forgot! Sorry!"
ToonTekst
TWENTY BINT58
$ "Press a key to proceed"
ToonTekst
WaitForKey
HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP
ZERO X!
COLA Entry
;									( end of ending sequence )

NAMELESS _ToonTekst
::
HARDBUFF 								( there is the text going to be displayed )
FOUR ROLL FOUR ROLL 						( get X and Y coordinate )
FOUR ROLL								( get the string )
DUPLEN$ FOUR #* 							( calculate length of string chars*4 )			
DISPXYmini								( unsupported Entry )
DROP									( and drop unsupported Entry )
;

NAMELESS _Exit
  ::
   LeaveGraphView
  ;
ASSEMBLE
endCode
RPL
ASSEMBLE
	Vfield DirVar,DirCode

* This variable will contain all the saved parameters of the aplet
* You can add your own variable in the list

RPL
  {
  ONE		( Add your default parameters here for the variable 'save' )
  TWO
  }
ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }
ASSEMBLE
	Vfield DirAlt,DirNot
RPL

**************************************************
*		     Note of the aplet			 *
**************************************************
* if you want to put text in a note do it here   *
* beneath, between the " "				 *
**************************************************

$ "Based on the famous television series. Here is it for you HP-39/40g! Answer fifteen questions correctly and you will be a euro millionaire. The keys are:\n[SK1] upperleft corner answer\n[SK2] upperright corner answer\n[SK3] bottomleft answer\n[SK4] bottomright answer\n[SK6] Helpline\nThe original version is for the TI-83(+) by Kenzo Tomita and Ewoud Huysmans\nThe HP-39/40g version is by Michal De Coninck.\nMail suggestions, bugs to ndco232@tiscalinet.be"

ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }



